//+------------------------------------------------------------------+
//|                                           NeutralHedge EA_v1.mq4 |
//|                                             2008.07.05 SwingMan |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright " 2008.07.05 SwingMan"
#property link      ""

#include <NeutralHedge_Library.mqh>

//+------------------------------------------------------------------+
//| External Variables                                               |
//+------------------------------------------------------------------+
extern string SubSymbol = "EURJPY";
extern string Last_OverlayTime = "";
//extern string Last_OverlayTime = "2008.07.02 20:00";
extern string ____Correlation____ = "1= correlated, 0=autom, -1= not correl";
extern int Pair_Correlation = 0;
extern int Period_Ratio = 72;
extern double Factor_Threshold = 0;
//--------------------------------------------------------------------

//---- variables
int TimeFrame = 0;
double Lots = 0.0;
int    Trend_Direction   = 0;
bool   Set_MarketOrder = false;
double Entry_Price      = 0.0;
double Exit_Price = 0.0;
bool   Set_BreakEven = true;
double BreakEven_Points = 10;
bool   Set_TrailingStop = true;
bool   Set_StopAndReverseExit = true;
bool   Exit_AtClose = true;
double Factor_BreakEven;

//-- constants
double RiscFactor = 2;

//+------------------------------------------------------------------+
string sName = "NeutralHedge EA_v1 ";
int    Magic = 20080705;
string accCurrency;
string sObject = "NH_EA1_";
int fontSize_Text = 8;
int iLabelCorner = 1;
int xx1 = 80;
int xx2 = 2;
int xx3 = 60;
int xx4 = 30;
int yy0 = 13, yy;
int yStep = 10;

//+------------------------------------------------------------------+
//| Internal variables                                               |
//+------------------------------------------------------------------+
int    PricePerPip;
double DecimalCorrection;
int    DecimalPlaces;
double MaxLots;

bool   OKToTrade, InputsChecked;
int    nOpenOrders, nPendingOrders;

bool   BuyFlag, SellFlag;
bool   StopLossAdjust;

int    ticket[6];
int maxOpenOrders = 1;
#define Slippage_Entry 5
#define Slippage_Exit 10

bool   StartUp;
datetime thisTime, oldTime;

string sComment, sSymbol, sWindow;
//-- System trading --------------------------------------------------
int TradeSignal;
int iDigits;
double dPoints, dOffsetEntry, Spread;
double dStopLevel;
double orderLots;

int ma_Shift = 1;
double dATR2;

//---- Entry
int iTradingLevel;
double EntryPrice, EntryPriceBuy, EntryPriceSel;
double Stop1Buy,Targ1Buy;
double Stop1Sel,Targ1Sel;
double TrailingStop;
bool bEntryDirectionChanged, bEntryValueChanged, bTradingLevelChanged;
datetime EntryTime;

//---- Trading
int TradeDirection;
int ticket_BUYPosition, ticket_SELLPosition;
bool TradeAlowed;

//-- variables NeutralHedge
double dMainRangePrice, dSubRangePrice;
string MainSymbol = "";

int Offset_Ratio;
datetime Last_Time;
bool Correlation = true;
double dPoint;
int iWindow = 0;
int firstBar, lastBar;
datetime firstTime, lastTime;
double Close_Main, Close_Sub;
double HedgeRange, threshold;
bool Trade_EntryTimeOK;


//## include library #############
//#include <H1System_Library.mqh>
//################################

//+------------------------------------------------------------------+
//| init
//+------------------------------------------------------------------+
int init()
{
   HideTestIndicators(false);
//---- Arrays
//   ArraySetAsSeries(CCIBuffer, true);     

//---- Check inputs
/*   Check_Inputs();   
   if (OKToTrade == false) 
      return(-1);*/
   
//---- init Trading   
   if (TimeFrame == 0) TimeFrame = Period();
   sWindow = sName + " (" + Get_sPeriod(TimeFrame)+") ";
   sSymbol = Symbol();
   accCurrency = AccountCurrency();
   
   dPoints = MarketInfo(Symbol(), MODE_POINT);

   iDigits = MarketInfo(Symbol(), MODE_DIGITS);
   Spread  = MarketInfo(Symbol(), MODE_SPREAD) * dPoints;
   dStopLevel= MarketInfo(Symbol(), MODE_STOPLEVEL) * dPoints;
   if (dStopLevel==0) dStopLevel = Ask-Bid;

   iTradingLevel = 0;
/*   
   bool bOpenOrders = Check_ActiveOrders(sSymbol, Magic);

   if(nOpenOrders==0)   {
      StartUp=true;
      BuyFlag =false;
      SellFlag=false;
   } else {
      StartUp=false;
      if(nOpenOrders == maxOpenOrders) {
         StopLossAdjust =false;
         //MoneyManagement=false;
      } else {
         StopLossAdjust =true;
         //MoneyManagement=true;
      }

      Get_TradingData(sSymbol, Magic);
   }  
   */
   
   Initialise_NeutralHedge();
   return(0);
}


//+------------------------------------------------------------------+
//| initialization
//+------------------------------------------------------------------+
int Initialise_NeutralHedge()
{  
   if (MainSymbol == "") MainSymbol = Symbol();
   Set_DefaultPairCorrelation(MainSymbol, Pair_Correlation, SubSymbol, Correlation);
Correlation = false;   
   if (SubSymbol == "") {Alert("SubSymbol is missing!"); return;}
  
   dPoint     = MarketInfo(MainSymbol, MODE_POINT);
//Print("mainSymbol= ",MainSymbol,"  SubSymbol= ",SubSymbol);
   //-- check time input   
   if (Last_OverlayTime == "") {
      Offset_Ratio = 0;
      Last_Time = iTime(MainSymbol, Period(), 0);
      Trade_EntryTimeOK = true;
   } else {
      Last_Time = StrToTime(Last_OverlayTime);      
      if (Last_Time > iTime(MainSymbol, Period(), 0)) {
         Trade_EntryTimeOK = false;
         string st = MainSymbol + " input ERROR: false Last_OverlayTime (" +Last_OverlayTime+")";
         Alert(st);   
      } else
         Trade_EntryTimeOK = true;
      if (Trade_EntryTimeOK == true)
         Offset_Ratio = iBarShift(MainSymbol, 0, Last_Time);
   }
   
   firstTime = iTime(MainSymbol, Period(), Offset_Ratio + Period_Ratio);
   lastTime  = iTime(MainSymbol, Period(), Offset_Ratio);  
     
   firstBar = iBarShift(MainSymbol, Period(), firstTime);
   lastBar  = iBarShift(MainSymbol, Period(), lastTime);

//Print("EA1. Last_Time= ",TimeToStr(Last_Time), "  Offset_Ratio= ",Offset_Ratio,"  Period_Ratio= ",Period_Ratio);
//Print("EA1. MainSymbol= ",MainSymbol,"  SubSymbol= ",SubSymbol);      
//Print("EA1. firstBar= ",firstBar,"  lastBar= ",lastBar);   
      
            
   IndicatorDigits(Digits);
     
   DeleteOwnObjects(sObject);

//   if (Send_TradingOrder == true) Send_MarketOrderTwoPairs();
   
   return(0);
}


//+------------------------------------------------------------------+
//| deinit
//+------------------------------------------------------------------+
int deinit()
{
   DeleteOwnObjects(sObject);
   return(0);
}

//+------------------------------------------------------------------+
//| Main code                                                        |
//+------------------------------------------------------------------+
int start()
{
//   if (OKToTrade==false) return(-1);
   int i;
   bool bLongEntryOK, bShrtEntryOK;
   
 
   //+---------------------------------------------------------------+
   //| Start-Up Routine (To Prevent Immediate Entry During Start-Up) |
   //+---------------------------------------------------------------+
   /*if (StartUp)
   {
      if (MathMod(Hour(),TimeFrame) == 0) {
         StartUp   = false;
      } else {
         Comment("Starting Up Delay. Awaiting Next Candle.");
         return(0);
      }
   }*/

   //+---------------------------------------------------------------+
   //| Main Trading Routine                                          |
   //+---------------------------------------------------------------+         
      EntryTime = 0;
//      bool bOpenOrders    = Check_ActiveOrders(sSymbol, Magic);

      int iEntryBar = iBarShift(Symbol(),0,EntryTime,false);

         CalculateIndicators();
//   Print("1. dMainRangePrice= ",dMainRangePrice,"  dSubRangePrice= ",dMainRangePrice);
         
      //==============================================================
      //##############################################################
      //==============================================================
      //+------------------------------------------------------------+
      //| Signal & Indicators
      //| for every new bar
      //+------------------------------------------------------------+
      thisTime = iTime(Symbol(),Period(),0);
      if (thisTime != oldTime) {
         oldTime = thisTime;
//Print("  thisTime=",thisTime,"  EntryTime=",EntryTime);
         //-- check and close all orders (at new days)
/*         if (nOpenOrders>0) {
            if (iEntryBar > 0)
               Close_ActiveOrders(Symbol(), Magic);
         }   */

         TradeAlowed = true; // for new days   
         
         //-- calculate trend and indicators
         CalculateIndicators();
        
         //-- 1.1 nOpenOrders == 0 and nPendingOrders == 0
         //--     Check_EntryOnUpperLevel         
         
         //-- 1.2 OpenOrders == 0 and PendingOrders == 0
         //--     Check_EntryCondition
         if(nOpenOrders==0 && nPendingOrders==0) {
            StartUp =true;
            BuyFlag =false;
            SellFlag=false;
            iTradingLevel = 0;
//            Check_EntryCondition();
            return(0);
         }                  
/*
      //-- Check missed orders
      //TradeAlowed = Get_SLTP_TradeAlowed();
      if (TradeAlowed == true && nOpenOrders ==0 && nPendingOrders ==0)
         Check_EntryCondition();
      
      //-- Disable PendingOrders
      if (TradeAlowed == true && nPendingOrders > 0) {
         //-- LONG trade
         if (TradeDirection == 1) {
            if (Bid <= EntryPriceSel) {
               Close_PendingOrders(Symbol(), Magic);               
            }
         } else
         //-- SHORT trade
         if (TradeDirection == -1) {
            if (Bid >= EntryPriceBuy) {
               Close_PendingOrders(Symbol(), Magic);               
            }
         }*/
      }
/*      
      //-- Check SL and TP
      if (TradeAlowed == true && nOpenOrders ==0 && nPendingOrders ==0) {
         double dHigh = iHigh(Symbol(), TimeFrame,0);
         double dLow  = iLow(Symbol(), TimeFrame,0);
         if (TradeDirection == 1) {
            if (Targ1Buy > 0 && dHigh >= Targ1Buy) TradeAlowed = false;
            if (Stop1Buy > 0 && dLow  <= Stop1Buy) TradeAlowed = false; 
         } else
         if (TradeDirection == -1) {
            if (Targ1Sel > 0 && dLow  <= Targ1Sel) TradeAlowed = false;
            if (Stop1Sel > 0 && dHigh >= Stop1Sel) TradeAlowed = false; 
         }           
      }
*/
      //==============================================================
      //##############################################################
      //==============================================================      
      //+------------------------------------------------------------+
      //| If Trade hit T2, sell half position
      //| If Trade hit T3, move StopLoss to BE
      //| If Trade hit T4, move StopLoss to T1
      //| If Trade hit T6, move StopLoss to T2      
      //+------------------------------------------------------------+
/*      if (nOpenOrders>0){ 
            Check_ChangeTradingLevels();
            if (bTradingLevelChanged) return(0);
      }   */
      
      //+------------------------------------------------------------+
      //| If Trade one hit TakeProfit, move StopLoss to BreakEven    |
      //+------------------------------------------------------------+
/*      if (StopLossAdjust==false)
      {
         if ( (nOpenOrders > 1) && ((BuyFlag && Bid>=Targ1Buy) || (SellFlag && Ask<=Targ1Sel)) )
         {
            for(i=2;i<=5;i++) {
               OrderSelect(ticket[i],SELECT_BY_TICKET);
               OrderModify(ticket[i],OrderOpenPrice(),EntryPrice,OrderTakeProfit(),0,CLR_NONE);
            }
            StopLossAdjust=true;
         }
      }*/

      //+------------------------------------------------------------+
      //| Set Trailing Stop
      //+------------------------------------------------------------+   
//      Set_TrailingStop();   
      
         
//      Write_Comment();

   return(0);
}
//####################################################################

//+------------------------------------------------------------------+
//    Calculate Indicators
//+------------------------------------------------------------------+
void CalculateIndicators()
{
   dMainRangePrice = iClose(Symbol(), 0, 0);      
/*//   dSubRangePrice  = iCustom(Symbol(), 0, "NeutralHedge Overlay_v4", 
// SubSymbol,Last_OverlayTime,____Correlation____,Pair_Correlation,Period_Ratio,Factor_Threshold, 0, Period_Ratio-1);
   dSubRangePrice  = iCustom(Symbol(), 0, "NeutralHedge Overlay_v4", 
      Symbol(),SubSymbol,Last_OverlayTime,____Correlation____,Pair_Correlation,Period_Ratio,Factor_Threshold, 0, 1);
*/   
   if (SubSymbol == "") return(-1);
   
   double CurRangeHigh, CurRangeLow, CurRangeCenter;
   double SubRangeHigh, SubRangeLow, SubRangeCenter, SubClose;
   double PipsRatio;
   
   //-- Calculate Chart Ratio
   CurRangeHigh  = iHigh( MainSymbol, 0, iHighest(MainSymbol, 0, MODE_HIGH, Period_Ratio, lastBar));
   CurRangeLow   = iLow (MainSymbol,  0, iLowest(MainSymbol,  0, MODE_LOW,  Period_Ratio, lastBar));
   CurRangeCenter= ( CurRangeHigh + CurRangeLow ) * 0.5;
Print("CurRangeHigh= ",CurRangeHigh,"  CurRangeLow= ",CurRangeLow,"  Correlation= ",Correlation);

   if ( Correlation == false ) {
      SubRangeHigh = iLow(  SubSymbol, 0, iLowest( SubSymbol, 0, MODE_LOW, Period_Ratio, lastBar ) );
      SubRangeLow  = iHigh( SubSymbol, 0, iHighest(SubSymbol, 0, MODE_HIGH,Period_Ratio, lastBar ) );
   } else {
      SubRangeHigh = iHigh( SubSymbol, 0, iHighest(SubSymbol, 0, MODE_HIGH,Period_Ratio, lastBar ) );
      SubRangeLow  = iLow(  SubSymbol, 0, iLowest( SubSymbol, 0, MODE_LOW, Period_Ratio, lastBar ) );
   }
Print("SubRangeHigh= ",SubRangeHigh,"  SubRangeLow= ",SubRangeLow);
//Print("2. firstBar= ",firstBar,"  lastBar= ",lastBar);

   SubRangeCenter = ( SubRangeHigh + SubRangeLow ) * 0.5;
   PipsRatio = ( CurRangeHigh - CurRangeLow )  / ( SubRangeHigh - SubRangeLow );
   
   // Draw ratio   
   //for (int iBar = lastBar; iBar < firstBar; iBar++) {
//   for (int iBar = firstBar; iBar > lastBar; iBar--) {   
   int iBar = 0;
   double xxClose = iClose( SubSymbol, 0, iBar );
      SubClose = iClose( SubSymbol, 0, iBar ) - SubRangeCenter;
      Close_Sub = CurRangeCenter + SubClose * PipsRatio;      
      
Print("CurRangeCenter= ",CurRangeCenter,"  SubRangeCenter= ",SubRangeCenter,"  PipsRatio= ",PipsRatio);
Print("xxClose= ",xxClose);
   
//      SubPrice[iBar] = Close_Sub;   //-- price in EA
   dSubRangePrice = Close_Sub;
//   }   
   
   Write_WinLossTrading();   
}


//+------------------------------------------------------------------+
//    Draw Threshold Lines
//+------------------------------------------------------------------+
void Write_WinLossTrading()
{
   //test Trade_EntryTime = "2008.07.02 20:00";   
//   if (Trade_EntryTime == "") return;
   
   double WinLoss;
   string text1, text2, sEmpty = "EMPTY";
   int Digits_Sub = MarketInfo(SubSymbol,MODE_DIGITS);
   double dPoint_Sub = MarketInfo(SubSymbol,MODE_POINT);
      
   yy = yy0;
//   iWindow = WindowFind(sWindow);
   iLabelCorner = 1;

   //-- trading results
   string sOrder_Main = Symbol() + ": " + DoubleToStr(dMainRangePrice,Digits);
   string sOrder_Sub  = SubSymbol + ": "+ DoubleToStr(dSubRangePrice,Digits_Sub);

   
   //-- write results
   //......................................................

   //======================================================
   Write_Label(iWindow, iLabelCorner, sObject, sOrder_Main, "", xx2, xx2, yy); yy = yy + yStep;  
   Write_Label(iWindow, iLabelCorner, sObject, sOrder_Sub, "", xx2, xx2, yy); yy = yy + yStep;   
      
   
   /*
   int entryBar = iBarShift(Symbol(),0,StrToTime(Trade_EntryTime),true);   
   double Entry_Main = iClose(Symbol(), 0, entryBar);
   double Entry_Sub  = iClose(SubSymbol, 0, entryBar);
   
   double Price_Main = iClose(Symbol(), 0, 0);
   double Price_Sub  = iClose(SubSymbol, 0, 0);
   
   //-- WinLoss results
   WinLoss = 0;   
   if (Order_MainPair == OP_BUY) {
      double Diff_Main = (Price_Main - Entry_Main) / dPoint;
      double Diff_Sub  = (Entry_Sub - Price_Sub) / dPoint_Sub;
      WinLoss = Diff_Main + Diff_Sub;
      string sOrder_Main = "buy " + Symbol() + ": " + 
                           DoubleToStr(Entry_Main,Digits) + " / " + DoubleToStr(Price_Main,Digits) +
                           " = " + DoubleToStr(Diff_Main,0);
      string sOrder_Sub  = "sell " + SubSymbol + ": " + 
                           DoubleToStr(Entry_Sub,Digits_Sub) + " / " + DoubleToStr(Price_Sub,Digits_Sub) +
                           " = " + DoubleToStr(Diff_Sub,0);
   } else 
   if (Order_MainPair == OP_SELL) {
      Diff_Main = -(Price_Main - Entry_Main) / dPoint;
      Diff_Sub  = -(Entry_Sub - Price_Sub) / dPoint_Sub;
      WinLoss = Diff_Main + Diff_Sub;
      sOrder_Main = "sell " + Symbol() + ": " + 
                           DoubleToStr(Entry_Main,Digits) + " / " + DoubleToStr(Price_Main,Digits) +
                           " = " + DoubleToStr(Diff_Main,0);
      sOrder_Sub  = "buy " + SubSymbol + ": " + 
                           DoubleToStr(Entry_Sub,Digits_Sub) + " / " + DoubleToStr(Price_Sub,Digits_Sub) +
                           " = " + DoubleToStr(Diff_Sub,0);
   } else {
      sOrder_Main = Symbol() + ": " + 
                           "NONE" + " / " + DoubleToStr(Price_Main,Digits);
      sOrder_Sub  = SubSymbol + ": " + 
                           "NONE" + " / " + DoubleToStr(Price_Sub,Digits);
   }
   
   //-- maxWin results
   double maxWin = -EMPTY_VALUE; 
   double mPrice_Main, mPrice_Sub, mDiff_Main, mDiff_Sub, mWinLoss;
   int iBar;  
   if (Order_MainPair == OP_BUY) {
      for (iBar =0; iBar < entryBar; iBar++) {
         mPrice_Main = iClose(Symbol(), 0, iBar);
         mPrice_Sub  = iClose(SubSymbol, 0, iBar);
         mDiff_Main = (mPrice_Main - Entry_Main) / dPoint;
         mDiff_Sub  = (Entry_Sub - mPrice_Sub) / dPoint_Sub;
         mWinLoss = mDiff_Main + mDiff_Sub;
         if (mWinLoss > maxWin) maxWin = mWinLoss;
      }
   } else 
   if (Order_MainPair == OP_SELL) {
      for (iBar =0; iBar < entryBar; iBar++) {
         mPrice_Main = iClose(Symbol(), 0, iBar);
         mPrice_Sub  = iClose(SubSymbol, 0, iBar);
         mDiff_Main = -(mPrice_Main - Entry_Main) / dPoint;
         mDiff_Sub  = -(Entry_Sub - mPrice_Sub) / dPoint_Sub;
         mWinLoss = mDiff_Main + mDiff_Sub;
         if (mWinLoss > maxWin) maxWin = mWinLoss;
      }   
   }

   //-- write results
   //......................................................
   text1 = "Entry time:";
   text2 = Trade_EntryTime;
   Write_Label(iWindow, iLabelCorner, sObject, text1, text2, xx1+10, xx2, yy); yy = yy + yStep;

   //======================================================
   Write_Label(iWindow, iLabelCorner, sObject, sOrder_Main, "", xx2, xx2, yy); yy = yy + yStep;  
   Write_Label(iWindow, iLabelCorner, sObject, sOrder_Sub, "", xx2, xx2, yy); yy = yy + yStep;   
   
   //======================================================
   text1 = "WinLoss: " + DoubleToStr(WinLoss,0) + " (max= " + DoubleToStr(maxWin,0) + ")";
   Write_Label(iWindow, iLabelCorner, sObject, text1, "", xx2, xx2, yy); yy = yy + yStep;
   */
}


//####################################################################
//+------------------------------------------------------------------+
//    Check Entry Condition
//+------------------------------------------------------------------+
void Check_EntryCondition()
{
/*
   if (Get_SLTP_TradeAlowed() == false) return;
   //-- LONG trade
   if (TradeDirection == 1) {
      SendOrder_BuyStop();
   } else
   if (TradeDirection == -1) {
      SendOrder_SellStop();   
   }*/
}


//+------------------------------------------------------------------+
//    Send_ErrorDescription
//+------------------------------------------------------------------+
void Send_ErrorDescription()
{
   int err=GetLastError(); 
   Alert(Symbol()," error(",err,"): ",ErrorDescription(err));
}


/*
//+------------------------------------------------------------------+
//    Write Comment
//+------------------------------------------------------------------+
void Write_Comment()
{
   string sText = sName + "\n";
   string sData = StringConcatenate(""
        ,"\n\nLots = "     ,Lots
        ,"\nBuyFlag = "    ,BuyFlag
        ,"\nSellFlag = "   ,SellFlag
        ,"\nEntryPrice=",  EntryPrice);
   string sTickets;     
   if (nOpenOrders > 0) sTickets =            StringConcatenate("\n\nticket1 = "  ,ticket[1]);     
   sText = sText + sData + sTickets;
   Comment(sText);
   return;
}*/

/*
//####################################################################
//+------------------------------------------------------------------+
//    Get Trading Data
//+------------------------------------------------------------------+
void Get_TradingData(string sSymbol, int iMagicNumber)
{
   int x = maxOpenOrders - nOpenOrders;
   for(int i=0;i<OrdersTotal();i++)
   {
      if ( OrderSelect(i, SELECT_BY_POS, MODE_TRADES) && 
           OrderSymbol()==sSymbol && 
           OrderMagicNumber() == iMagicNumber &&
           OrderCloseTime()==0) 
      {
         x++;
         ticket[x] =OrderTicket();
         EntryPrice=OrderOpenPrice();
         if(OrderType()==OP_BUY) {
            BuyFlag =true;
            SellFlag=false;
         } else
         if(OrderType()==OP_SELL) {
            BuyFlag =false;
            SellFlag=true;
         }
         //if (MoneyManagement==false) 
         Lots = OrderLots();
      }
   }
   return;
}      */

//+------------------------------------------------------------------+
//    Get sPeriod
//+------------------------------------------------------------------+
string Get_sPeriod(int timeframe)
{
   if (timeframe == PERIOD_M1) return("M1");
   if (timeframe == PERIOD_M5) return("M5");
   if (timeframe == PERIOD_M15) return("M15");
   if (timeframe == PERIOD_M30) return("M30");
   if (timeframe == PERIOD_H1) return("H1");
   if (timeframe == PERIOD_H4) return("H4");
   if (timeframe == PERIOD_D1) return("D1");
   if (timeframe == PERIOD_W1) return("W1");
   if (timeframe == PERIOD_MN1) return("MN1");   
}

/*
//+------------------------------------------------------------------+
//    Get Order Lots
//+------------------------------------------------------------------+
void Get_OrderLots()
{  
   orderLots = 0.01;
   return;

   double minLots   = MarketInfo(Symbol(), MODE_MINLOT);
   double TickValue = MarketInfo(Symbol(), MODE_TICKVALUE); // std Account
   
   double TickValueAccount  = TickValue * minLots;   
   double TickSize  = MarketInfo(Symbol(), MODE_TICKSIZE);
      
   double Balance   = AccountBalance();
   double RiscTitle = (Balance / nTitles) * (RiscFactor/100);
   double dATR = iATR(Symbol(),Period(),Period_ATR,1);
   double dATRPoints = dATR / TickSize;
   double RiscATR   = dATRPoints * TickValueAccount;
   
   double nLots = RiscTitle / (ATRFactor*RiscATR);
   nLots = 0.1 * nLots  / maxOpenOrders;
   
   if (minLots == 1.0)  orderLots = NormalizeDouble(nLots,0);
   if (minLots == 0.10) orderLots = NormalizeDouble(nLots,1);
   if (minLots == 0.01) orderLots = NormalizeDouble(nLots,2);
   return;
}*/

/*
//####################################################################
//+------------------------------------------------------------------+
//| Check inputs
//+------------------------------------------------------------------+
void Check_Inputs()
{
   OKToTrade = true;
   return;
   
   //---- check period H1
   if (Period() != PERIOD_H1) {
      OKToTrade = false;
      Alert(Symbol() + ":  The System is guilty only for H1 !");
   }

   //---- check trade allowed
   if (IsTradeAllowed() == false) {
      OKToTrade = false;
      Alert(Symbol() + ":  Enable checkbox #Allow live trading# in the expert properties !");
   }
   
   return;
   //=================================================================
   
   if (Lots == 0.0) {
      OKToTrade = false;
      Alert("For " + Symbol() + "  Lots = 0");
   }
   if (Trend_Direction == 0) {
      OKToTrade = false;
      Alert("For " + Symbol() + "  Trend Direction = 0");
   }
   if (Entry_Price == 0 && Set_MarketOrder == false) {
      OKToTrade = false;
      Alert("For " + Symbol() + "  Entry Price = 0");
   }
   return;
}*/