//+------------------------------------------------------------------+
//|                                   NeutralHedge oLogPriceDiff.mq4 |
//|                                             2008.07.26 SwingMan |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright " 2008.07.26 SwingMan"
#property link      ""

#property indicator_separate_window

#property indicator_buffers 4
#property indicator_color1 DeepSkyBlue
#property indicator_color2 MediumTurquoise
#property indicator_color3 Tomato
#property indicator_color4 SpringGreen

//---- inputs --------------------------------------------------------
extern string Pair1 = "GBPUSD";
extern string Pair2 = "EURUSD";
extern int maxBars = 1000;
extern int Period_Differences = 100;
extern double Factor_StdDev = 1.0;
//--------------------------------------------------------------------

double Difference[], ZeroLine[];
double LineUp[], LineDn[];

//---------------------------------------------------------------------------------|
//                                                                                 |
//---------------------------------------------------------------------------------|
int init()
{
   SetIndexBuffer(0,Difference); SetIndexLabel(0,"Difference"); SetIndexStyle(0,DRAW_HISTOGRAM,STYLE_SOLID,2);
   SetIndexBuffer(1,ZeroLine); SetIndexLabel(1,"MeanLine"); SetIndexStyle(1,DRAW_LINE);
   SetIndexBuffer(2,LineUp); SetIndexLabel(2,"Line Up"); SetIndexStyle(2,DRAW_LINE);
   SetIndexBuffer(3,LineDn); SetIndexLabel(3,"Line Dn"); SetIndexStyle(3,DRAW_LINE);
   
   string st = "LogPriceDifference ("+Pair1+"--"+Pair2+ ", " + Period_Differences;
   st = st + ") ";
   IndicatorShortName(st);
   return(0);
}

//---------------------------------------------------------------------------------|
//                                                                                 |
//---------------------------------------------------------------------------------|
int deinit()
{
   return(0);
}

//---------------------------------------------------------------------------------|
//                                                                                 |
//---------------------------------------------------------------------------------|
int start() 
{  
   int counted_bars = IndicatorCounted();
   int i, limit;
   
   if (counted_bars < 0) return(-1);
   if (counted_bars > 0) counted_bars--;
   limit=Bars - counted_bars;
   limit=maxBars;
  
   for (i=0;i<limit + Period_Differences;i++)
   {  
      Difference[i] = MathAbs(MathLog(iClose(Pair1, 0, i)) - MathLog(iClose(Pair2, 0, i)));
      //Difference[i] = MathLog(iClose(Pair1, 0, i)) - MathLog(iClose(Pair2, 0, i));
   }
   
   for (i=0;i<limit + Period_Differences;i++)
   {  
      ZeroLine[i] = iMAOnArray(Difference,0, Period_Differences, 0, MODE_SMA, i);
      double DevRanges = iStdDevOnArray(Difference,0, Period_Differences, 0, MODE_SMA, i);
      
      LineUp[i] = ZeroLine[i] + DevRanges *Factor_StdDev;
      LineDn[i] = ZeroLine[i] - DevRanges *Factor_StdDev;
   }

   return(0);
}

