//+------------------------------------------------------------------+
//|                                   NeutralHedge oOCDifference.mq4 |
//|                                             2008.07.24 SwingMan |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright " 2008.07.24 SwingMan"
#property link      ""

#property indicator_separate_window

#property indicator_buffers 2
#property indicator_color1 YellowGreen
#property indicator_color2 DeepSkyBlue

#property indicator_level1 0

//---- inputs --------------------------------------------------------
extern string Pair1 = "GBPUSD";
extern string Pair2 = "EURUSD";
extern int maxBars = 1000;
extern int Period_OpenClose_Differences = 96;
extern bool ShowRealDifferences = false;
//--------------------------------------------------------------------

double Difference1[], Difference2[];
double Line1[], Line2[];

//---------------------------------------------------------------------------------|
//                                                                                 |
//---------------------------------------------------------------------------------|
int init()
{
   ArraySetAsSeries(Difference1,true);
   ArraySetAsSeries(Difference2,true);
   
   SetIndexBuffer(0,Line1); SetIndexLabel(0,"OCdiff "+Pair1); SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(1,Line2); SetIndexLabel(1,"OCdiff "+Pair2); SetIndexStyle(1,DRAW_LINE);

   string st = "OpenCloseDifferences ("+Pair1+"--"+Pair2+ ", " + Period_OpenClose_Differences;
   st = st + ") ";
   IndicatorShortName(st);
   return(0);
}

//---------------------------------------------------------------------------------|
//                                                                                 |
//---------------------------------------------------------------------------------|
int deinit()
{
   return(0);
}

//---------------------------------------------------------------------------------|
//                                                                                 |
//---------------------------------------------------------------------------------|
int start() 
{  
   ArrayResize(Difference1, Bars);
   ArrayResize(Difference2, Bars);
   
   int counted_bars = IndicatorCounted();
   int i, limit;
   
   if (counted_bars < 0) return(-1);
   if (counted_bars > 0) counted_bars--;
   limit=Bars - counted_bars;
   limit=0;//maxBars;
  
   for (i=0;i<limit + Period_OpenClose_Differences;i++)
   {  
      Difference1[i] = iClose(Pair1, Period(), i) - iOpen(Pair1, Period(), i);
      Difference2[i] = iClose(Pair2, Period(), i) - iOpen(Pair2, Period(), i);
   }
   
   Line1[limit + Period_OpenClose_Differences] = 0;
   Line2[limit + Period_OpenClose_Differences] = 0;
   
   for (i=limit + Period_OpenClose_Differences-1; i >=0; i--)
   {  
      if (ShowRealDifferences) {
         Line1[i] = Line1[i+1] + Difference1[i];
         Line2[i] = Line2[i+1] + Difference2[i];
      }
      else
      {
         if (Difference1[i] > 0) int digit1 = 1; else
         if (Difference1[i] < 0) digit1 = -1; else digit1 = 0;      
         if (Difference2[i] > 0) int digit2 = 1; else
         if (Difference2[i] < 0) digit2 = -1; else digit2 = 0;
      
         Line1[i] = Line1[i+1] + digit1;
         Line2[i] = Line2[i+1] + digit2;
      }      
   }
   return(0);
}