//+------------------------------------------------------------------+
//|                                             oPriceComparison.mq4 |
//|                                             2008.07.26 SwingMan |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright " 2008.07.26 SwingMan"
#property link      ""

#property indicator_separate_window

#property indicator_buffers 4
#property indicator_color1 DeepSkyBlue
#property indicator_color2 MediumTurquoise
#property indicator_color3 Tomato
#property indicator_color4 SpringGreen

//---- inputs --------------------------------------------------------
extern string Pair1 = "GBPUSD";
extern string Pair2 = "EURUSD";
extern int maxBars = 1000;
extern int Period_Differences = 100;
extern double Factor_StdDev = 1.0;
extern bool PipsDifference = true;
//--------------------------------------------------------------------

double Difference[], ZeroLine[];
double LineUp[], LineDn[];

double TickValue1, TickValue2, TickSize1, TickSize2;

//---------------------------------------------------------------------------------|
//                                                                                 |
//---------------------------------------------------------------------------------|
int init()
{
   SetIndexBuffer(0,Difference); SetIndexLabel(0,"Difference"); SetIndexStyle(0,DRAW_HISTOGRAM,STYLE_SOLID,2);
   SetIndexBuffer(1,ZeroLine); SetIndexLabel(1,"ZeroLine"); SetIndexStyle(1,DRAW_LINE);
   SetIndexBuffer(2,LineUp); SetIndexLabel(2,"Short Line"); SetIndexStyle(2,DRAW_LINE);
   SetIndexBuffer(3,LineDn); SetIndexLabel(3,"Long Line"); SetIndexStyle(3,DRAW_LINE);
   
   string sCurrency = AccountCurrency();
   TickValue1 = MarketInfo(Pair1, MODE_TICKVALUE);
   TickValue2 = MarketInfo(Pair2, MODE_TICKVALUE);   
   TickSize1  = MarketInfo(Pair1, MODE_TICKSIZE);
   TickSize2  = MarketInfo(Pair2, MODE_TICKSIZE);   
   
   if (PipsDifference)
      string st = "Pips Difference ("+Pair1+"--"+Pair2+ ", " + Period_Differences;
   else
      st = sCurrency + " Difference ("+Pair1+"--"+Pair2+ ", " + Period_Differences +
           ", " + DoubleToStr(TickValue1,2) + ", " + DoubleToStr(TickValue2,2);
   st = st + ") ";
   
   IndicatorShortName(st);
   return(0);
}

//---------------------------------------------------------------------------------|
//                                                                                 |
//---------------------------------------------------------------------------------|
int deinit()
{
   return(0);
}

//---------------------------------------------------------------------------------|
//                                                                                 |
//---------------------------------------------------------------------------------|
int start() 
{  
   int counted_bars = IndicatorCounted();
   int i, limit;
   double dClose1, dClose2;

   if (counted_bars < 0) return(-1);
   if (counted_bars > 0) counted_bars--;
   //limit=Bars - counted_bars;
   limit=maxBars;   
   
   for (i=0;i<limit + Period_Differences;i++)
   {    
      dClose1 = iClose(Pair1, Period(), i);
      dClose2 = iClose(Pair2, Period(), i);
      
      if (PipsDifference)   
         Difference[i] = dClose1 - dClose2 ;
         //Difference[i] = dClose1 / TickSize1 - dClose2 / TickSize2;
      else
         Difference[i] = dClose1 * TickValue1 - dClose2 * TickValue2;
   }
   
   for (i=0;i<limit + Period_Differences;i++)
   {  
      ZeroLine[i] = iMAOnArray(Difference,0, Period_Differences, 0, MODE_SMA, i);
      double DevRanges = iStdDevOnArray(Difference,0, Period_Differences, 0, MODE_SMA, i);
      
      LineUp[i] = ZeroLine[i] + DevRanges *Factor_StdDev;
      LineDn[i] = ZeroLine[i] - DevRanges *Factor_StdDev;
   }   
   return(0);
}