//+------------------------------------------------------------------+
//|                                NeutralHedge oPriceDifference.mq4 |
//|                                             2008.07.24 SwingMan |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright " 2008.07.24 SwingMan"
#property link      ""

#property indicator_separate_window

#property indicator_buffers 2
#property indicator_color1 DeepSkyBlue
#property indicator_color2 YellowGreen

//---- inputs --------------------------------------------------------
extern string Pair1 = "GBPUSD";
extern string Pair2 = "EURUSD";
extern int maxBars = 1000;
extern int Period_HiLo_Differences = 100;
//--------------------------------------------------------------------

double Difference[], ZeroLine[];

//---------------------------------------------------------------------------------|
//                                                                                 |
//---------------------------------------------------------------------------------|
int init()
{
   SetIndexBuffer(0,Difference); SetIndexLabel(0,"Difference"); SetIndexStyle(0,DRAW_HISTOGRAM,STYLE_SOLID,2);
   SetIndexBuffer(1,ZeroLine); SetIndexLabel(1,"ZeroLine"); SetIndexStyle(1,DRAW_LINE);
   
   string st = "PriceDifference ("+Pair1+"--"+Pair2+ ", " + Period_HiLo_Differences;
   st = st + ") ";
   IndicatorShortName(st);
   return(0);
}

//---------------------------------------------------------------------------------|
//                                                                                 |
//---------------------------------------------------------------------------------|
int deinit()
{
   return(0);
}

//---------------------------------------------------------------------------------|
//                                                                                 |
//---------------------------------------------------------------------------------|
int start() 
{  
   int counted_bars = IndicatorCounted();
   int i, limit;
   
   if (counted_bars < 0) return(-1);
   if (counted_bars > 0) counted_bars--;
   limit=Bars - counted_bars;
   limit=maxBars;
  
   for (i=0;i<limit + Period_HiLo_Differences;i++)
   {  
      Difference[i] = iClose(Pair1, 0, i) - iClose(Pair2, 0, i);
   }
   
   for (i=0;i<limit + Period_HiLo_Differences;i++)
   {  
      double maxDifference = Get_maxDifference(i, Difference, Period_HiLo_Differences);
      double minDifference = Get_minDifference(i, Difference, Period_HiLo_Differences);
      ZeroLine[i] = (maxDifference + minDifference) * 0.50;
   }
   return(0);
}

double Get_maxDifference(int iBar, double Difference[], int PeriodHiLo)
{
   double maxDiff = Difference[iBar];
   for (int i=0; i < PeriodHiLo; i++) {
      double newMax = MathMax(Difference[iBar+i], Difference[iBar+i+1]);
      if (newMax > maxDiff) maxDiff = newMax;
   }   
   return(maxDiff);
}

double Get_minDifference(int iBar, double Difference[], int PeriodHiLo)
{
   double minDiff = Difference[iBar];
   for (int i=0; i < PeriodHiLo; i++) {
      double newMin = MathMin(Difference[iBar+i], Difference[iBar+i+1]);
      if (newMin < minDiff) minDiff = newMin;
   }
   return(minDiff);
}